<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../">
  <title data-ice="title">src/core/DataSource.js | API Document</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  
  
  <script src="script/manual.js"></script>
</head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
</header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><div data-ice="dirPath" class="nav-dir-path">core</div><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/core/Core.js~Core.html">Core</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/core/DataSource.js~DataSource.html">DataSource</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/core/Dataset.js~Dataset.html">Dataset</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/core/Environment.js~Environment.html">Environment</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/core/Timeline.js~Timeline.html">Timeline</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-core">core</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-dataSource">dataSource</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-dataset">dataset</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-environment">environment</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-timeline">timeline</a></span></span></li>
<li data-ice="doc"><div data-ice="dirPath" class="nav-dir-path">debug</div><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/debug/TimelineDebug.js~TimelineDebug.html">TimelineDebug</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-timelineDebug">timelineDebug</a></span></span></li>
<li data-ice="doc"><div data-ice="dirPath" class="nav-dir-path">tool</div><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/tool/QueryString.js~QueryString.html">QueryString</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-queryString">queryString</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/core/DataSource.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">let instance = null;
/**
 * The global datasource instance for use by jsonp
 * @type {string}
 */
const DataSourceGlobal = &quot;window.SB.Data&quot;;

/**
 * To assist with switchboard data handling on local and remote deployments
 */
class DataSource {

  /**
   * @see instance()
   */
  constructor(core) {
    if (!instance) {
      this._core = core;
      this._sources = [];
      this._completeCallback = null;
      this._jsonpCallbacks = { i:0 };

      this._global = DataSourceGlobal;

      instance = this;
    }
    return instance;
  }

  /**
   * Get the singleton instance of DataSource
   * @return {DataSource} The DataSource singleton
   */
  static instance() {
    return new DataSource();
  }

  /**
   * Load data from switchboard for local development
   * @param  {object}   config   See example for full configuration
   *
   * @example
   * SB.Data.load({
   * 	url:&apos;http://demo.coatesdigital.com.au&apos;,
   * 	sources: [
   * 		{ name:&apos;config&apos;, filename:&apos;basic-menu-config.csv&apos; },
   * 		&apos;basic-product-group-nutrition.csv&apos;
   * 	],
   * 	success: function () {
   * 		// start application
   * 	}
   * });
   */
  load(config) {
    this._completeCallback = config.success || function () {};

    let base = config.url || &apos;&apos;;
    let location = config.location || &apos;&apos;;
    this._sources = config.sources || [];

    if (this._core.local &amp;&amp;
        this._sources.length &gt; 0) {
      window.Switchboard.dataSources = {};

      // get each source map
      this._sources.map(s =&gt; {
        let source = typeof(s) == &apos;string&apos; ? s : s.filename;
        let name = typeof(s.name) != &apos;undefined&apos; ? s.name : source;
        let datasource = this._toAPIFormat(base, location) + source + &apos;.jsonp&apos;;

        // setup callback
        let jsonpName = &quot;fn&quot; + this._jsonpCallbacks.i++;
        this._jsonpCallbacks[jsonpName] = ((dn, fn) =&gt; {
          let that = this;
          return function () {
            delete that._jsonpCallbacks[fn];

            let args = Array.prototype.slice.call(arguments);
            args.unshift(dn);
            that._complete.apply(that, args);
          };

        })(name, jsonpName);

        // get data via jsonp
        this._jsonp(datasource, jsonpName);
      });
    } else {
      // compatability
      if (this._core.compatability) {
        window.Switchboard.dataSources = window.data;
      }
      //
      this._completeCallback();
    }
  }

  /**
   * Get a data source from Switchboard
   * @param  {string} name Name of file or custom name
   * @return {Array}      Data from Switchboard
   *
   * @example
   * SB.Data.load({
   * 	url:&apos;http://demo.coatesdigital.com.au&apos;,
   * 	sources: [
   * 		{ name:&apos;config&apos;, filename:&apos;basic-menu-config.csv&apos; },
   * 		&apos;basic-products.csv&apos;
   * 	],
   * 	success: function () {
   * 		SB.Data.get(&apos;config&apos;); // returns basic-menu-config.csv
   *   	SB.Data.get(&apos;basic-menu-config.csv&apos;); // returns the same
   * 	  SB.Data.get(&apos;basic-products.csv&apos;); // returns basic-products.csv
   * 	  SB.Data.get(&apos;not-a-data-source&apos;); // throws error
   * 	}
   * });
   */
  get(name) {
    // exists with name
    if (typeof(window.Switchboard.dataSources[name]) !== &apos;undefined&apos;)
      return this._toArray(window.Switchboard.dataSources[name]);
    // find source with name and use filename
    for (let i = 0; i &lt; this._sources.length; i++) {
      let s = this._sources[i];

      if (typeof(s) === &apos;string&apos;) continue;
      if (name == s.name &amp;&amp;
          typeof(window.Switchboard.dataSources[s.filename]) !== &apos;undefined&apos;)
          return this._toArray(window.Switchboard.dataSources[s.filename]);
    }
    // nothing exists
    throw new Error(&apos;DataSource does not exist in Switchboard.dataSource&apos;);
  }

  /**
   * Update a data source with new data
   * @param {update} name The name of the data source to update
   * @param {Array} data The data to store
   *
   * @example
   * SB.Data.load({
   * 	url:&apos;http://demo.coatesdigital.com.au&apos;,
   * 	sources: [
   * 		{ name:&apos;prices&apos;, filename:&apos;basic-prices.csv&apos; },
   * 		{ name:&apos;products&apos;, filename:&apos;basic-products.csv&apos; }
   * 	],
   * 	success: function () {
   * 		var joinedDataset = SB.Dataset(SB.Data(products))
   * 				.join(SB.Data(prices)).on(&apos;id&apos;)
   * 			 	.get();
   *    SB.Data.set(&apos;products&apos;, joinedDataset); // overwrite with the newly combined dataset
   * 	}
   * });
   */
  set(name, data) {
    if (typeof(window.Switchboard.dataSources[name]) === &apos;undefined&apos;) {
      let notFound = name;
      // find source with name and use filename
      for (let i = 0; i &lt; this._sources.length; i++) {
        let s = this._sources[i];

        if (typeof(s) === &apos;string&apos;) continue;
        if (name == s.name &amp;&amp;
            typeof(window.Switchboard.dataSources[s.filename]) !== &apos;undefined&apos;)
            name = s.filename;
      }
    }

    window.Switchboard.dataSources[name] = data;
  }

  /**
   * Verify a data source exists
   * @param  {string}  name Name of file or custom name
   * @return {Boolean}      Data source exists
   *
   * @example
   * SB.Data.load({
   * 	url:&apos;http://demo.coatesdigital.com.au&apos;,
   * 	sources: [
   * 		{ name:&apos;config&apos;, filename:&apos;basic-menu-config.csv&apos; },
   * 		&apos;basic-products.csv&apos;
   * 	],
   * 	success: function () {
   * 	 SB.Data.has(&apos;config&apos;); // returns true
   * 	 SB.Data.has(&apos;basic-menu-config.csv&apos;); // returns true
   * 	 SB.Data.has(&apos;not-a-data-source&apos;); // returns false}
   * });
   */
  has(name) {
    try {
      this.get(name);
    } catch (e) {
      return false;
    }
    return true;
  }

  /**
   * Add data and verify complete data load
   * @param  {string} name The name of the data source that has loaded
   * @param  {Array} data The data to store to the Switchboard object
   */
  _complete(name, data) {
    window.Switchboard.dataSources[name] = data;
    // verify all sources loaded
    let complete = true;
    for (let i = 0; i &lt; this._sources.length; i++) {
      let s = this._sources[i];
      let source = typeof(s) == &apos;string&apos; ? s : s.filename;
      let name = typeof(s.name) != &apos;undefined&apos; ? s.name : source;

      if (typeof(window.Switchboard.dataSources[name]) === &apos;undefined&apos;)
        complete = false;
    }
    if (complete) this._completeCallback();
  }

  /**
   * Formats url to include api path
   * @param  {string} url The url to format
   * @return {string}     The formatted url
   */
  _toAPIFormat(url, location) {
    if (location) {
      if (url[url.length - 1] != &apos;/&apos;)
        url += &apos;/&apos;;
      url += `local/${location}/`;
    }

    if (url.indexOf(&apos;/api/dataSource/&apos;) &lt; 0) {
      if (url[url.length - 1] != &apos;/&apos;)
        url += &apos;/&apos;;
      return url + &apos;api/dataSource/&apos;;
    }
  }

  /**
   * Generates a script element from parameters
   * @param  {string} src          The url to the data source
   * @param  {string} callbackName The function name to call on data load
   * @return {HTMLElement}              Script HTML Element
   */
  _toScriptTag(src, callbackName) {
    let script = document.createElement(&apos;script&apos;);
    script.src = `${src}?callback=${DataSourceGlobal}._jsonpCallbacks.${callbackName}`;
    script.dataset.switchboard = true;
    return script;
  }

  /**
   * Start JSONP
   * @param  {string} src          The url to the data source
   * @param  {string} callbackName The function name to call on data load
   */
  _jsonp(src, callbackName) {
    document.body.appendChild(this._toScriptTag(src, callbackName));
  }

  /**
   * Convert array-like data to an array if possible
   * @param  {object} data The data to convert
   * @return {Array}      The data as an Array
   */
  _toArray(data) {
    if (data instanceof Array)
      return Array.from(data);
    return data;
  }
}

/**
 * Assists with loading and accessing Switchboard data
 */
export default DataSource;
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(0.4.3)</span></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
